#Install JPEG 2000 support
#apt-get install openjpeg-tools

import random
import glob
import os
import sys



def getRandomImageMagickParam():
	param = ""

	resize_quality = random.randint(1, 16);

	if resize_quality == 1:
		param = param + "-define filter:filter=Sinc -define filter:window=Jinc -define filter:lobes=3 "
	if resize_quality == 2:
		param = param + "-define filter:filter=Sinc -define filter:window=Jinc -define filter:lobes=3 "
				
	if resize_quality == 3:
		param = param + "-filter Sinc "
	if resize_quality == 4:
		param = param + "-filter Sinc "
	if resize_quality == 5:
		param = param + "-filter Sinc "
	if resize_quality == 6:
		param = param + "-filter Sinc "
		
	if resize_quality == 7:
		param = param + "-filter Gaussian "
	if resize_quality == 8:
		param = param + "-filter Gaussian "
	if resize_quality == 9:
		param = param + "-filter Point "
		
	dither = random.randint(1, 60);
	if dither == 1:
		param = param + "-ordered-dither checks,32 "
	if dither == 2:
		param = param + "-ordered-dither o8x8,32 "
	if dither == 3:
		param = param + "-dither FloydSteinberg -colors 64 "
	if dither == 4:
		param = param + "-dither Riemersma -colors 64 "
	
	contrast = random.randint(1, 60);
	if contrast == 1:
		param = param + "-sigmoidal-contrast 0.5 "
	if contrast == 2:
		param = param + "-sigmoidal-contrast 2.5 "
	if contrast == 3:
		param = param + "-sigmoidal-contrast 4.0 "
	if contrast == 4:
		param = param + "-sigmoidal-contrast 6.0 "

	sharpen = random.randint(1, 40);
	if sharpen == 1:
		param = param + "-sharpen 1x1 "
	if sharpen == 2:
		param = param + "-sharpen 2x2 "
	if sharpen == 3:
		param = param + "-sharpen 3x3 "
	if sharpen == 4:
		param = param + "-sharpen 4x4 "
	if sharpen == 5:
		param = param + "-sharpen 5x5 "
	if sharpen == 6:
		param = param + "-sharpen 6x6 "

	asharpen = random.randint(1, 30);
	if asharpen == 1:
		param = param + "-adaptive-sharpen 1 "
	if asharpen == 2:
		param = param + "-adaptive-sharpen 2 "
	if asharpen == 3:
		param = param + "-adaptive-sharpen 3 "

	blur = random.randint(1, 55);
	if blur == 1:
		param = param + "-blur 0x1 "
	if blur == 2:
		param = param + "-blur 1x0 "
	if blur == 3:
		param = param + "-blur 1x1 "
	if blur == 4:
		param = param + "-blur 2x0 "
	if blur == 5:
		param = param + "-blur 0x2 "
	if blur == 6:
		param = param + "-blur 2x2 "
	if blur == 7:
		param = param + "-blur 1x1 "
	if blur == 8:
		param = param + "-blur 1x1 "
	if blur == 9:
		param = param + "-blur 1x1 "
	if blur == 10:
		param = param + "-blur 1x1 "

	blur = random.randint(1, 55);
	blurangle = random.randint(1, 359);
	if blur == 1:
		param = param + "-motion-blur 0x1+" + str(blurangle) + " " #anlge
	if blur == 2:
		param = param + "-motion-blur 1x0+" + str(blurangle) + " " #anlge
	if blur == 3:
		param = param + "-motion-blur 1x1+" + str(blurangle) + " " #anlge
	if blur == 4:
		param = param + "-motion-blur 2x0+" + str(blurangle) + " " #anlge
	if blur == 5:
		param = param + "-motion-blur 0x2+" + str(blurangle) + " " #anlge
	if blur == 6:
		param = param + "-motion-blur 2x2+" + str(blurangle) + " " #anlge
	if blur == 7:
		param = param + "-motion-blur 0x3+" + str(blurangle) + " " #anlge
	if blur == 8:
		param = param + "-motion-blur 3x0+" + str(blurangle) + " " #anlge
	if blur == 9:
		param = param + "-motion-blur 3x3+" + str(blurangle) + " " #anlge
	if blur == 10:
		param = param + "-motion-blur 3x1+" + str(blurangle) + " " #anlge
	if blur == 11:
		param = param + "-motion-blur 1x3+" + str(blurangle) + " " #anlge
	if blur == 12:
		param = param + "-motion-blur 1x1+" + str(blurangle) + " " #anlge
	if blur == 13:
		param = param + "-motion-blur 1x1+" + str(blurangle) + " " #anlge
	if blur == 14:
		param = param + "-motion-blur 1x1+" + str(blurangle) + " " #anlge

	#autogamma = random.randint(1, 35); #use only rarely (bad quality!)
	#if autogamma == 1:
	#	param = param + "-auto-gamma "

	normalize = random.randint(1, 15); 
	if normalize == 1:
		param = param + "-normalize "

	posterize = random.randint(1, 50);
	if posterize == 1:
		param = param + "-posterize 16 "

	quality = random.randint(1, 20);
	if quality == 1:
		param = param + "-quality 35 "
	if quality == 2:
		param = param + "-quality 35 " 
	if quality == 3:
		param = param + "-quality 35 "
	if quality == 4:
		param = param + "-quality 50 "
	if quality == 5:
		param = param + "-quality 50 "
	if quality == 6:
		param = param + "-quality 50 "
	if quality == 7:
		param = param + "-quality 70 "
	if quality == 8:
		param = param + "-quality 70 "
	if quality == 9:
		param = param + "-quality 80 "
	if quality == 10:
		param = param + "-quality 80 "
	if quality == 11:
		param = param + "-quality 80 "
	if quality == 12:
		param = param + "-quality 90 "
	if quality == 13:
		param = param + "-quality 90 "
	if quality == 14:
		param = param + "-quality 90 "
	if quality == 15:
		param = param + "-quality 90 "
	if quality == 16:
		param = param + "-quality 90 "
	if quality == 17:
		param = param + "-quality 90 "
	if quality == 18:
		param = param + "-quality 92 "
	if quality == 19:
		param = param + "-quality 95 "
	if quality == 20:
		param = param + "-quality 99 "

	gamma = random.randint(1, 60);
	if gamma == 1:
		param = param + "-gamma .5 "
	if gamma == 2:
		param = param + "-gamma .6 "
	if gamma == 3:
		param = param + "-gamma .7 "
	if gamma == 4:
		param = param + "-gamma .8 "
	if gamma == 5:
		param = param + "-gamma .8 "
	if gamma == 6:
		param = param + "-gamma .9 "
	if gamma == 7:
		param = param + "-gamma .9 "
	if gamma == 8:
		param = param + "-gamma 1.2 "
	if gamma == 9:
		param = param + "-gamma 1.2 "				
	if gamma == 10:
		param = param + "-gamma 1.4 "
	if gamma == 11:
		param = param + "-gamma 1.4 "
	if gamma == 12:
		param = param + "-gamma 1.6 "
	if gamma == 13:
		param = param + "-gamma 1.8 "
	if gamma == 14:
		param = param + "-gamma 2.0 "

	brightness = 100 #(100 + random.randint(0, 200) + random.randint(0, 200) + random.randint(0, 200) + random.randint(0, 200)) / 5
	saturation = (100 + random.randint(0, 200) + random.randint(0, 200) + random.randint(0, 200) + random.randint(0, 200) + random.randint(0, 200) + random.randint(0, 200)) / 7
	tint = (100 + random.randint(80, 120) + random.randint(80, 120) + random.randint(80, 120)) / 4

	modulate = random.randint(1, 12);
	if modulate == 1:
		param = param + "-modulate " + str(brightness) + "," + str(saturation) + "," + str(tint) + " "
	
	modulate = random.randint(1, 35);
	if modulate == 1:
		param = param + "-modulate 100,0,100 "

	brightness = (0 + random.randint(0, 100) + random.randint(0, 100) + random.randint(0, 100) + random.randint(0, 100) - random.randint(0, 100) - random.randint(0, 100) - random.randint(0, 100) - random.randint(0, 100)) / 6
	contrast = (0 + random.randint(0, 100) + random.randint(0, 100) + random.randint(0, 100) + random.randint(0, 100) - random.randint(0, 100) - random.randint(0, 100) - random.randint(0, 100) - random.randint(0, 100)) / 6

	brightnesscontrast = random.randint(1, 12);
	if brightnesscontrast == 1:
		param = param + "-brightness-contrast " + str(brightness) + "x" + str(contrast) + " "

	noise = random.randint(1, 50); #ugly, only use rarely
	if noise == 1:
		param = param + "-noise 1 +noise Gaussian -attenuate 0.008 "
	if noise == 2:
		param = param + "-noise 2 +noise Uniform -attenuate 0.008 "
	if noise == 3:
		param = param + "-noise 1 +noise Uniform -attenuate 0.016 "
	if noise == 4:
		param = param + "-noise 2 +noise Gaussian -attenuate 0.016 "
	if noise == 5:
		param = param + "-noise 3 +noise Gaussian -attenuate 0.008 "
	if noise == 6:
		param = param + "+noise Impulse "
	
	resize = random.randint(1, 50);

	if resize == 1:
		param = param + "-resize 64x64 "		
	if resize == 2:
		param = param + "-resize 56x56 "
	if resize == 3:
		param = param + "-resize 52x52 "
	if resize == 4:
		param = param + "-resize 48x48 "				
					
	param = param + "-resize 72x72 "	

	#print param
	return param

def manipulateImage(file):
		param = getRandomImageMagickParam()
		file_in_qutes = "\"" + file + "\""
		#print param
		jpeg2000_compress = random.randint(1, 10);

		if (jpeg2000_compress == 1) and (param.find("noise")==-1):		
			os.system("convert " +file_in_qutes +" " +  param + " -colorspace RGB /tmp/tmp1.bmp3")
			os.system("image_to_j2k -i /tmp/tmp1.bmp3 -o /tmp/tmp.jp2 -q " + str(random.randint(30, 50)) )
			os.system("j2k_to_image -i /tmp/tmp.jp2 -o /tmp/tmp2.bmp")			
			os.system("convert /tmp/tmp2.bmp " + " -quality 90 " + file_in_qutes)
		else:
			os.system("convert " + file_in_qutes + " " +  param + file_in_qutes)
			
		low_freq_noise = random.randint(1, 8);
		noise_sz = str(random.randint(3, 28))
		noise_gamma = str(random.randint(10, 25)/10.0)
		noise_colorfullness = str(random.randint(0, 45))
		if low_freq_noise == 1:
			os.system("convert -size " + noise_sz + "x" + noise_sz + " xc:black -filter Gaussian +noise Gaussian -modulate 100," + noise_colorfullness + ",100 -resize 32x32 -gamma "+noise_gamma+" -blur 1x1 -resize 72x72 /tmp/noise1.jpg")
			os.system("convert -size " + noise_sz + "x" + noise_sz + " xc:black -filter Gaussian +noise Gaussian -modulate 100," + noise_colorfullness + ",100 -resize 32x32 -gamma "+noise_gamma+" -blur 1x1 -resize 72x72 /tmp/noise2.jpg")			
			
			if random.randint(0, 99) >= 50:
				os.system("composite -compose plus " + file_in_qutes + " /tmp/noise1.jpg -quality 95 /tmp/tmp3.jpg")
				os.system("composite -compose minus /tmp/tmp3.jpg /tmp/noise2.jpg -quality 95 " + file_in_qutes)
			else:
				os.system("composite -compose minus " + file_in_qutes + " /tmp/noise1.jpg -quality 95 /tmp/tmp3.jpg")
				os.system("composite -compose plus /tmp/tmp3.jpg /tmp/noise2.jpg -quality 95 " + file_in_qutes)			


path = raw_input("Enter the path of your image file which should be manipulated: ")
for face in range(1,524): 
	print face
	filelist = glob.glob(path + str(face) + "/*.jpg")
	for file in filelist:
		manipulateImage(file)
